/*
 * JS for Home generated by Appery.io
 */

Apperyio.getProjectGUID = function() {
    return '7b9f9836-7a04-4eae-ad6d-de2548047cae';
};

function navigateTo(outcome, useAjax) {
    Apperyio.navigateTo(outcome, useAjax);
}

// Deprecated


function adjustContentHeight() {
    Apperyio.adjustContentHeightWithPadding();
}

function adjustContentHeightWithPadding(_page) {
    Apperyio.adjustContentHeightWithPadding(_page);
}

function setDetailContent(pageUrl) {
    Apperyio.setDetailContent(pageUrl);
}

Apperyio.AppPages = [{
    "name": "ContactUs",
    "location": "#ContactUs"
}, {
    "name": "DoctorDetails",
    "location": "#DoctorDetails"
}, {
    "name": "Home",
    "location": "#Home"
}, {
    "name": "Update",
    "location": "#Update"
}, {
    "name": "SearchResults",
    "location": "#SearchResults"
}];

Home_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'HomePanelSwitchButton': 'Home_HomePanelSwitchButton',
        'CategoriesSelectMenu': 'Home_CategoriesSelectMenu',
        'CategoriesSelectMenu-0': 'Home_CategoriesSelectMenu-0',
        'SpecialtiesSelectMenu': 'Home_SpecialtiesSelectMenu',
        'SpecialtiesSelectMenu-0': 'Home_SpecialtiesSelectMenu-0',
        'AreasSelectMenu': 'Home_AreasSelectMenu',
        'AreasSelectMenu-0': 'Home_AreasSelectMenu-0',
        'HomeSpacer': 'Home_HomeSpacer',
        'HomeSearchButton': 'Home_HomeSearchButton',
        'MessageLabel': 'Home_MessageLabel',
        'HomeButton': 'Home_HomeButton',
        'spacer_3': 'Home_spacer_3',
        'ContactUsButton': 'Home_ContactUsButton',
        'spacer_5': 'Home_spacer_5',
        'UpdateButton': 'Home_UpdateButton'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'Home';

    /*
     * Nonvisual components
     */
    var datasources = [];

    categoriesListServer = new Apperyio.DataSource(cairomedicDB_categories_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            try {
                specialtiesListServer.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "categories"(_objectId TEXT, categoryName TEXT, categoryID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "categories" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "categories" (_objectId, categoryName, categoryID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?)', [value._id, value.categoryName, value.categoryID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(categoriesListServer);

    specialtiesListServer = new Apperyio.DataSource(cairomedicDB_specialties_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            try {
                areasListServer.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "specialties"(_objectId TEXT, specialtyName TEXT, specialtyID INTEGER, categoryID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "specialties" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "specialties" (_objectId, specialtyName, specialtyID, categoryID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?, ?)', [value._id, value.specialtyName, value.specialtyID, value.categoryID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(specialtiesListServer);

    areasListServer = new Apperyio.DataSource(cairomedicDB_areas_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            try {
                contactUsListServer.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "areas"(_objectId TEXT, areaName TEXT, areaID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "areas" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "areas" (_objectId, areaName, areaID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?)', [value._id, value.areaName, value.areaID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(areasListServer);

    doctorsListServer = new Apperyio.DataSource(cairomedicDB_doctors_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            try {
                getCategoriesLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
            try {
                getAreasLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "doctors"(_objectId TEXT, doctorTitle TEXT, doctorName TEXT, doctorAdd TEXT, doctorTel TEXT, doctorMob TEXT, doctorDetails TEXT, doctorLatitude REAL, doctorLongitude REAL, doctorID INTEGER, categoryID INTEGER, specialtyID INTEGER, areaID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "doctors" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "doctors" (_objectId, doctorTitle, doctorName, doctorAdd, doctorTel, doctorMob, doctorDetails, doctorLatitude, doctorLongitude, doctorID, categoryID, specialtyID, areaID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [value._id, value.doctorTitle, value.doctorName, value.doctorAdd, value.doctorTel, value.doctorMob, value.doctorDetails, value.doctorLatitude, value.doctorLongitude, value.doctorID, value.categoryID, value.specialtyID, value.areaID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }, {
            'PATH': ['limit'],
            'TYPE': 'STRING',
            'ATTR': '40000'
        }, {
            'PATH': ['sort'],
            'TYPE': 'STRING',
            'ATTR': 'doctorID'
        }]
    });

    datasources.push(doctorsListServer);

    getCategoriesLocal = new Apperyio.DataSource(getCategories, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            localStorage.setItem('category', '1');
            try {
                getSpecialtiesLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': 'CategoriesSelectMenu-0',
            'SET': [{
                'PATH': ['categoryName'],
                'ID': 'CategoriesSelectMenu-0',
                'ATTR': '@'
            }, {
                'PATH': ['categoryID'],
                'ID': 'CategoriesSelectMenu-0',
                'ATTR': 'value'
            }, {
                'PATH': ['categoryID'],
                'ID': '___local_storage___',
                'ATTR': 'category'
            }]
        }],
        'requestMapping': []
    });

    datasources.push(getCategoriesLocal);

    getSpecialtiesLocal = new Apperyio.DataSource(getSpecialties, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            setVar_('specialty', 'Home_SpecialtiesSelectMenu', 'value', '', this);
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': 'SpecialtiesSelectMenu-0',
            'SET': [{
                'PATH': ['specialtyName'],
                'ID': 'SpecialtiesSelectMenu-0',
                'ATTR': '@'
            }, {
                'PATH': ['specialtyID'],
                'ID': 'SpecialtiesSelectMenu-0',
                'ATTR': 'value'
            }, {
                'PATH': ['specialtyID'],
                'ID': '___local_storage___',
                'ATTR': 'specialty'
            }]
        }],
        'requestMapping': []
    });

    datasources.push(getSpecialtiesLocal);

    getAreasLocal = new Apperyio.DataSource(getAreas, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            setVar_('area', 'Home_AreasSelectMenu', 'value', '', this);
            toggle('Home_MessageLabel', 'mob', 'false');
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': 'AreasSelectMenu-0',
            'SET': [{
                'PATH': ['areaName'],
                'ID': 'AreasSelectMenu-0',
                'ATTR': '@'
            }, {
                'PATH': ['areaID'],
                'ID': 'AreasSelectMenu-0',
                'ATTR': 'value'
            }, {
                'PATH': ['areaID'],
                'ID': '___local_storage___',
                'ATTR': 'area'
            }]
        }],
        'requestMapping': []
    });

    datasources.push(getAreasLocal);

    contactUsListServer = new Apperyio.DataSource(cairomedicDB_contactUs_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Home");
        },
        'onSuccess': function(data) {
            try {
                doctorsListServer.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "contactUs"(_objectId TEXT, Details TEXT, Mob1 TEXT, Mob2 TEXT, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "contactUs" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "contactUs" (_objectId, Details, Mob1, Mob2, _createdAt, _updatedAt) values (?, ?, ?, ?, ?, ?)', [value._id, value.Details, value.Mob1, value.Mob2, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(contactUsListServer);

    /*
     * Events and handlers
     */

    // Before Show
    var Home_beforeshow = function() {
            Apperyio.CurrentScreen = "Home";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var Home_onLoad = function() {
            Home_elementsExtraJS();

            try {
                getCategoriesLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
            try {
                getAreasLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };

            // TODO fire device events only if necessary (with JS logic)
            Home_deviceEvents();
            Home_windowEvents();
            Home_elementsEvents();
        };

    // screen window events
    var Home_windowEvents = function() {

            $('#Home').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });

        };

    // device events
    var Home_deviceEvents = function() {
            document.addEventListener("deviceready", function() {
                var firstrun = window.localStorage.getItem("runned");
                if (firstrun === null) {

                    window.localStorage.setItem("runned", "1");
                    categoriesListServer.execute({});

                } else {

                    getCategoriesLocal.execute({});
                    getAreasLocal.execute({});

                };
                toggle('Home_MessageLabel', 'mob', 'true');

            });
        };

    // screen elements extra js
    var Home_elementsExtraJS = function() {
            // screen (Home) extra code

            /* CategoriesSelectMenu */

            $("#Home_CategoriesSelectMenu").parent().find("a.ui-btn").attr("tabindex", "2");

            /* SpecialtiesSelectMenu */

            $("#Home_SpecialtiesSelectMenu").parent().find("a.ui-btn").attr("tabindex", "3");

            /* AreasSelectMenu */

            $("#Home_AreasSelectMenu").parent().find("a.ui-btn").attr("tabindex", "4");

        };

    // screen elements handler
    var Home_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#Home_HomeHeader [name="HomePanelSwitchButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="Home_HomePanelMenu"]').panel("open");

                    }
                },
            }, '#Home_HomeHeader [name="HomePanelSwitchButton"]');

            $(document).off("change", '#Home_HomeContainer [name="CategoriesSelectMenu"]').on({
                change: function() {
                    setVar_('category', 'Home_CategoriesSelectMenu', 'value', '', this);
                    try {
                        getSpecialtiesLocal.execute({})
                    } catch (ex) {
                        console.log(ex.name + '  ' + ex.message);
                        hideSpinner();
                    };
                },
            }, '#Home_HomeContainer [name="CategoriesSelectMenu"]');

            $(document).off("change", '#Home_HomeContainer [name="SpecialtiesSelectMenu"]').on({
                change: function() {
                    setVar_('specialty', 'Home_SpecialtiesSelectMenu', 'value', '', this);
                },
            }, '#Home_HomeContainer [name="SpecialtiesSelectMenu"]');

            $(document).off("change", '#Home_HomeContainer [name="AreasSelectMenu"]').on({
                change: function() {
                    setVar_('area', 'Home_AreasSelectMenu', 'value', '', this);
                },
            }, '#Home_HomeContainer [name="AreasSelectMenu"]');

            $(document).off("click", '#Home_HomeContainer [name="HomeSearchButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        setVar_('category', 'Home_CategoriesSelectMenu', 'value', '', this);
                        setVar_('specialty', 'Home_SpecialtiesSelectMenu', 'value', '', this);
                        setVar_('area', 'Home_AreasSelectMenu', 'value', '', this);
                        Apperyio.navigateTo('SearchResults', {
                            reverse: false
                        });

                    }
                },
            }, '#Home_HomeContainer [name="HomeSearchButton"]');

            $(document).off("click", '[name="ContactUsButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('ContactUs', {
                            reverse: false
                        });

                    }
                },
            }, '[name="ContactUsButton"]');

            $(document).off("click", '[name="UpdateButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Update', {
                            reverse: false
                        });

                    }
                },
            }, '[name="UpdateButton"]');

        };

    $(document).off("pagebeforeshow", "#Home").on("pagebeforeshow", "#Home", function(event, ui) {
        Home_beforeshow();
    });

    if (runBeforeShow) {
        Home_beforeshow();
    } else {
        Home_onLoad();
    }
};

$(document).off("pagecreate", "#Home").on("pagecreate", "#Home", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    Home_js();
});

ContactUs_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'ContactUsPanelSwitchButton': 'ContactUs_ContactUsPanelSwitchButton',
        'ContactUsGrid': 'ContactUs_ContactUsGrid',
        'DetailsGridCell': 'ContactUs_DetailsGridCell',
        'DetailsLabel': 'ContactUs_DetailsLabel',
        'spacer_20': 'ContactUs_spacer_20',
        'Phone1GridCell': 'ContactUs_Phone1GridCell',
        'Phone1Grid': 'ContactUs_Phone1Grid',
        'Mob1PicGridCell': 'ContactUs_Mob1PicGridCell',
        'Mob1Image': 'ContactUs_Mob1Image',
        'Mob1NoGridCell': 'ContactUs_Mob1NoGridCell',
        'Mob1Label': 'ContactUs_Mob1Label',
        'spacer_23': 'ContactUs_spacer_23',
        'Phone2GridCell': 'ContactUs_Phone2GridCell',
        'Phone2Grid': 'ContactUs_Phone2Grid',
        'Mob2PicGridCell': 'ContactUs_Mob2PicGridCell',
        'Mob2Image': 'ContactUs_Mob2Image',
        'Mob2NoGridCell': 'ContactUs_Mob2NoGridCell',
        'Mob2Label': 'ContactUs_Mob2Label',
        'spacer_33': 'ContactUs_spacer_33',
        'HomeButton': 'ContactUs_HomeButton',
        'spacer_5': 'ContactUs_spacer_5',
        'ContactUsButton': 'ContactUs_ContactUsButton',
        'spacer_7': 'ContactUs_spacer_7',
        'UpdateButton': 'ContactUs_UpdateButton'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'ContactUs';

    /*
     * Nonvisual components
     */
    var datasources = [];

    contactUsLocal = new Apperyio.DataSource(getContactUs, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("ContactUs");
        },
        'onSuccess': function(data) {
            setVar_('ourmob1', 'ContactUs_Mob1Label', 'text', '', this);
            setVar_('ourmob2', 'ContactUs_Mob2Label', 'text', '', this);
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': 'ContactUsGrid',
            'SET': [{
                'PATH': ['Details'],
                'ID': 'DetailsLabel',
                'ATTR': '@'
            }, {
                'PATH': ['Mob1'],
                'ID': 'Mob1Label',
                'ATTR': '@'
            }, {
                'PATH': ['Mob2'],
                'ID': 'Mob2Label',
                'ATTR': '@'
            }, {
                'PATH': ['Mob1'],
                'ID': '___local_storage___',
                'ATTR': 'ourmob1'
            }, {
                'PATH': ['Mob2'],
                'ID': '___local_storage___',
                'ATTR': 'ourmob2'
            }]
        }],
        'requestMapping': []
    });

    datasources.push(contactUsLocal);

    /*
     * Events and handlers
     */

    // Before Show
    var ContactUs_beforeshow = function() {
            Apperyio.CurrentScreen = "ContactUs";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var ContactUs_onLoad = function() {
            ContactUs_elementsExtraJS();

            try {
                contactUsLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
            setVar_('ourmob1', 'ContactUs_Mob1Label', 'text', '', this);
            setVar_('ourmob2', 'ContactUs_Mob2Label', 'text', '', this);

            // TODO fire device events only if necessary (with JS logic)
            ContactUs_deviceEvents();
            ContactUs_windowEvents();
            ContactUs_elementsEvents();
        };

    // screen window events
    var ContactUs_windowEvents = function() {

            $('#ContactUs').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });
            $('#ContactUs').on({
                pageshow: function() {
                    try {
                        contactUsLocal.execute({})
                    } catch (ex) {
                        console.log(ex.name + '  ' + ex.message);
                        hideSpinner();
                    };
                    setVar_('ourmob1', 'ContactUs_Mob1Label', 'text', '', this);
                    setVar_('ourmob2', 'ContactUs_Mob2Label', 'text', '', this);
                },
            });

        };

    // device events
    var ContactUs_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var ContactUs_elementsExtraJS = function() {
            // screen (ContactUs) extra code

        };

    // screen elements handler
    var ContactUs_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#ContactUs_ContactUsHeader [name="ContactUsPanelSwitchButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="ContactUs_ContactUsPanelMenu"]').panel("open");

                    }
                },
            }, '#ContactUs_ContactUsHeader [name="ContactUsPanelSwitchButton"]');

            $(document).off("click", '#ContactUs_ContactUsContainer [name="Mob1Image"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        var mob = window.localStorage.getItem("ourmob1");
                        window.location.href = "tel:" + mob;

                    }
                },
            }, '#ContactUs_ContactUsContainer [name="Mob1Image"]');

            $(document).off("click", '#ContactUs_ContactUsContainer [name="Mob2Image"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        var mob = window.localStorage.getItem("ourmob2");
                        window.location.href = "tel:" + mob;

                    }
                },
            }, '#ContactUs_ContactUsContainer [name="Mob2Image"]');

            $(document).off("click", '[name="HomeButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Home', {
                            reverse: false
                        });

                    }
                },
            }, '[name="HomeButton"]');

            $(document).off("click", '[name="UpdateButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Update', {
                            reverse: false
                        });

                    }
                },
            }, '[name="UpdateButton"]');

        };

    $(document).off("pagebeforeshow", "#ContactUs").on("pagebeforeshow", "#ContactUs", function(event, ui) {
        ContactUs_beforeshow();
    });

    if (runBeforeShow) {
        ContactUs_beforeshow();
    } else {
        ContactUs_onLoad();
    }
};

$(document).off("pagecreate", "#ContactUs").on("pagecreate", "#ContactUs", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    ContactUs_js();
});

DoctorDetails_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'BackToSearchResultsButton': 'DoctorDetails_BackToSearchResultsButton',
        'DoctorDetailsPanelSwitchButton': 'DoctorDetails_DoctorDetailsPanelSwitchButton',
        'DoctorGrid': 'DoctorDetails_DoctorGrid',
        'DocTitleGridCell': 'DoctorDetails_DocTitleGridCell',
        'DocTitleLabel': 'DoctorDetails_DocTitleLabel',
        'spacer_42': 'DoctorDetails_spacer_42',
        'DocNameGridCell': 'DoctorDetails_DocNameGridCell',
        'DocNameLabel': 'DoctorDetails_DocNameLabel',
        'spacer_37': 'DoctorDetails_spacer_37',
        'DocAddGridCell': 'DoctorDetails_DocAddGridCell',
        'DocAddLabel': 'DoctorDetails_DocAddLabel',
        'spacer_38': 'DoctorDetails_spacer_38',
        'DocTelGridCell': 'DoctorDetails_DocTelGridCell',
        'DocTelGrid': 'DoctorDetails_DocTelGrid',
        'DocTelPicCell': 'DoctorDetails_DocTelPicCell',
        'DocTelPic': 'DoctorDetails_DocTelPic',
        'DocTelNumberCell': 'DoctorDetails_DocTelNumberCell',
        'DocTelLabel': 'DoctorDetails_DocTelLabel',
        'spacer_39': 'DoctorDetails_spacer_39',
        'DocMobGridCell': 'DoctorDetails_DocMobGridCell',
        'DocMobGrid': 'DoctorDetails_DocMobGrid',
        'DocMobPicCell': 'DoctorDetails_DocMobPicCell',
        'DocMobPic': 'DoctorDetails_DocMobPic',
        'DocMobNumberCell': 'DoctorDetails_DocMobNumberCell',
        'DocMobLabel': 'DoctorDetails_DocMobLabel',
        'spacer_40': 'DoctorDetails_spacer_40',
        'DocDetailsGridCell': 'DoctorDetails_DocDetailsGridCell',
        'DocDetailsLabel': 'DoctorDetails_DocDetailsLabel',
        'spacer_41': 'DoctorDetails_spacer_41',
        'map': 'DoctorDetails_map',
        'marker': 'DoctorDetails_marker',
        'HomeButton': 'DoctorDetails_HomeButton',
        'spacer_45': 'DoctorDetails_spacer_45',
        'ContactUsButton': 'DoctorDetails_ContactUsButton',
        'spacer_47': 'DoctorDetails_spacer_47',
        'UpdateButton': 'DoctorDetails_UpdateButton'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'DoctorDetails';

    /*
     * Nonvisual components
     */
    var datasources = [];

    getDoctorDetailsLocal = new Apperyio.DataSource(GetDoctor, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("DoctorDetails");
        },
        'onSuccess': function(data) {
            setAttribute_('DoctorDetails_map', 'latitude', localStorage.getItem('doclat'));
            $('[id="DoctorDetails_map"]').refresh();
            setAttribute_('DoctorDetails_map', 'longitude', localStorage.getItem('doclong'));
            $('[id="DoctorDetails_map"]').refresh();
            setVar_('doctel', 'DoctorDetails_DocTelLabel', 'text', '', this);
            setVar_('docmob', 'DoctorDetails_DocMobLabel', 'text', '', this);
            var map = Appery('map');
            map.refresh();
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': 'DoctorGrid',
            'SET': [{
                'PATH': ['doctorTitle'],
                'ID': 'DocTitleLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorName'],
                'ID': 'DocNameLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorAdd'],
                'ID': 'DocAddLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorTel'],
                'ID': 'DocTelLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorMob'],
                'ID': 'DocMobLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorDetails'],
                'ID': 'DocDetailsLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorLatitude'],
                'ID': '___local_storage___',
                'ATTR': 'doclat'
            }, {
                'PATH': ['doctorLongitude'],
                'ID': '___local_storage___',
                'ATTR': 'doclong'
            }, {
                'PATH': ['doctorTel'],
                'ID': '___local_storage___',
                'ATTR': 'doctel'
            }, {
                'PATH': ['doctorMob'],
                'ID': '___local_storage___',
                'ATTR': 'docmob'
            }]
        }],
        'requestMapping': []
    });

    datasources.push(getDoctorDetailsLocal);

    /*
     * Events and handlers
     */

    // Before Show
    var DoctorDetails_beforeshow = function() {
            Apperyio.CurrentScreen = "DoctorDetails";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var DoctorDetails_onLoad = function() {
            DoctorDetails_elementsExtraJS();

            try {
                getDoctorDetailsLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };

            // TODO fire device events only if necessary (with JS logic)
            DoctorDetails_deviceEvents();
            DoctorDetails_windowEvents();
            DoctorDetails_elementsEvents();
        };

    // screen window events
    var DoctorDetails_windowEvents = function() {

            $('#DoctorDetails').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });
            $('#DoctorDetails').on({
                pageshow: function() {
                    try {
                        getDoctorDetailsLocal.execute({})
                    } catch (ex) {
                        console.log(ex.name + '  ' + ex.message);
                        hideSpinner();
                    };
                },
            });

        };

    // device events
    var DoctorDetails_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var DoctorDetails_elementsExtraJS = function() {
            // screen (DoctorDetails) extra code

            /* map */

            $("[name = 'map']").wrap("<div/>");
            $("[name = 'map']").parent().css("margin-left", $("[name = 'map']").css("margin-left"));
            $("[name = 'map']").parent().css("margin-right", $("[name = 'map']").css("margin-right"));
            $("[name = 'map']").css("margin-left", '0');
            $("[name = 'map']").css("margin-right", '0');

            var map_options = {
                markerSourceName: "map_markers",
                latitude: "",
                longitude: "",
                address: "",
                zoom: 16,
                showLocationMarker: true
            }

            Apperyio.__registerComponent('map', new Apperyio.ApperyMapComponent("map", map_options));
            $("[name='map_markers'] [apperytype='marker']").attr("reRender", "map");
            $("[name='map']").closest("[data-role='page']").bind({
                pagecontainershow: function() {
                    if (Apperyio('map') != undefined) {
                        Apperyio('map').refresh();
                    }
                }
            });

        };

    // screen elements handler
    var DoctorDetails_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#DoctorDetails_DoctorDetailsHeader [name="BackToSearchResultsButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('SearchResults', {
                            reverse: false
                        });

                    }
                },
            }, '#DoctorDetails_DoctorDetailsHeader [name="BackToSearchResultsButton"]');
            $(document).off("click", '#DoctorDetails_DoctorDetailsHeader [name="DoctorDetailsPanelSwitchButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="DoctorDetails_DoctorDetailsPanelMenu"]').panel("open");

                    }
                },
            }, '#DoctorDetails_DoctorDetailsHeader [name="DoctorDetailsPanelSwitchButton"]');

            $(document).off("click", '#DoctorDetails_DoctorDetailsContainer [name="DocTelPic"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        var tele = window.localStorage.getItem("doctel");
                        window.location.href = "tel:" + tele;

                    }
                },
            }, '#DoctorDetails_DoctorDetailsContainer [name="DocTelPic"]');

            $(document).off("click", '#DoctorDetails_DoctorDetailsContainer [name="DocMobPic"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        var mob = window.localStorage.getItem("docmob");
                        window.location.href = "tel:" + mob;

                    }
                },
            }, '#DoctorDetails_DoctorDetailsContainer [name="DocMobPic"]');

            $(document).off("click", '[name="HomeButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Home', {
                            reverse: false
                        });

                    }
                },
            }, '[name="HomeButton"]');

            $(document).off("click", '[name="ContactUsButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('ContactUs', {
                            reverse: false
                        });

                    }
                },
            }, '[name="ContactUsButton"]');

            $(document).off("click", '[name="UpdateButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Update', {
                            reverse: false
                        });

                    }
                },
            }, '[name="UpdateButton"]');

        };

    $(document).off("pagebeforeshow", "#DoctorDetails").on("pagebeforeshow", "#DoctorDetails", function(event, ui) {
        DoctorDetails_beforeshow();
    });

    if (runBeforeShow) {
        DoctorDetails_beforeshow();
    } else {
        DoctorDetails_onLoad();
    }
};

$(document).off("pagecreate", "#DoctorDetails").on("pagecreate", "#DoctorDetails", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    DoctorDetails_js();
});

Update_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'UpdatePanelSwitchButton': 'Update_UpdatePanelSwitchButton',
        'UpdateLabel': 'Update_UpdateLabel',
        'spacer_10': 'Update_spacer_10',
        'UpdateNowButton': 'Update_UpdateNowButton',
        'MessageLabel': 'Update_MessageLabel',
        'HomeButton': 'Update_HomeButton',
        'spacer_5': 'Update_spacer_5',
        'ContactUsButton': 'Update_ContactUsButton',
        'spacer_7': 'Update_spacer_7',
        'UpdateButton': 'Update_UpdateButton'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'Update';

    /*
     * Nonvisual components
     */
    var datasources = [];

    categoriesListUpdate = new Apperyio.DataSource(cairomedicDB_categories_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Update");
        },
        'onSuccess': function(data) {
            try {
                specialtiesListUpdate.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(wx) {
                    wx.executeSql('DROP TABLE IF EXISTS "categories"');
                });

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "categories"(_objectId TEXT, categoryName TEXT, categoryID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "categories" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "categories" (_objectId, categoryName, categoryID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?)', [value._id, value.categoryName, value.categoryID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(categoriesListUpdate);

    specialtiesListUpdate = new Apperyio.DataSource(cairomedicDB_specialties_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Update");
        },
        'onSuccess': function(data) {
            try {
                areasListUpdate.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(wx) {
                    wx.executeSql('DROP TABLE IF EXISTS "specialties"');
                });

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "specialties"(_objectId TEXT, specialtyName TEXT, specialtyID INTEGER, categoryID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "specialties" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "specialties" (_objectId, specialtyName, specialtyID, categoryID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?, ?)', [value._id, value.specialtyName, value.specialtyID, value.categoryID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(specialtiesListUpdate);

    areasListUpdate = new Apperyio.DataSource(cairomedicDB_areas_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Update");
        },
        'onSuccess': function(data) {
            try {
                doctorsListUpdate.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(wx) {
                    wx.executeSql('DROP TABLE IF EXISTS "areas"');
                });

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "areas"(_objectId TEXT, areaName TEXT, areaID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "areas" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "areas" (_objectId, areaName, areaID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?)', [value._id, value.areaName, value.areaID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(areasListUpdate);

    doctorsListUpdate = new Apperyio.DataSource(cairomedicDB_doctors_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Update");
        },
        'onSuccess': function(data) {
            try {
                contactUsListUpdate.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(wx) {
                    wx.executeSql('DROP TABLE IF EXISTS "doctors"');
                });

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "doctors"(_objectId TEXT, doctorTitle TEXT, doctorName TEXT, doctorAdd TEXT, doctorTel TEXT, doctorMob TEXT, doctorDetails TEXT, doctorLatitude REAL, doctorLongitude REAL, doctorID INTEGER, categoryID INTEGER, specialtyID INTEGER, areaID INTEGER, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "doctors" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "doctors" (_objectId, doctorTitle, doctorName, doctorAdd, doctorTel, doctorMob, doctorDetails, doctorLatitude, doctorLongitude, doctorID, categoryID, specialtyID, areaID, _createdAt, _updatedAt) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [value._id, value.doctorTitle, value.doctorName, value.doctorAdd, value.doctorTel, value.doctorMob, value.doctorDetails, value.doctorLatitude, value.doctorLongitude, value.doctorID, value.categoryID, value.specialtyID, value.areaID, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }, {
            'PATH': ['limit'],
            'TYPE': 'STRING',
            'ATTR': '40000'
        }, {
            'PATH': ['sort'],
            'TYPE': 'STRING',
            'ATTR': 'doctorID'
        }]
    });

    datasources.push(doctorsListUpdate);

    contactUsListUpdate = new Apperyio.DataSource(cairomedicDB_contactUs_list_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("Update");
        },
        'onSuccess': function(data) {
            toggle('Update_MessageLabel', 'mob', 'false');
            alert("تم تحديث البيانات بنجاح");
        },
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': '___js___',
            'TRANSFORMATION': function(value, element) {
                var db = window.openDatabase("cairomedicDB", "1.0", "cairomedicDB", 1024 * 1000);

                db.transaction(function(wx) {
                    wx.executeSql('DROP TABLE IF EXISTS "contactUs"');
                });

                db.transaction(function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS "contactUs"(_objectId TEXT, Details TEXT, Mob1 TEXT, Mob2 TEXT, _createdAt DATETIME, _updatedAt DATETIME)', []);
                    tx.executeSql('SELECT * FROM "contactUs" WHERE "_objectId" = "' + value._id + '"', [], function(tx, results) {
                        console.log('rows :' + results.rows.length);
                        if (results.rows.length === 0) {
                            tx.executeSql('INSERT INTO "contactUs" (_objectId, Details, Mob1, Mob2, _createdAt, _updatedAt) values (?, ?, ?, ?, ?, ?)', [value._id, value.Details, value.Mob1, value.Mob2, value._createdAt, value._updatedAt]);
                        }
                    });
                });

                return;
            },
            'SET': []
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }]
    });

    datasources.push(contactUsListUpdate);

    /*
     * Events and handlers
     */

    // Before Show
    var Update_beforeshow = function() {
            Apperyio.CurrentScreen = "Update";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var Update_onLoad = function() {
            Update_elementsExtraJS();

            // TODO fire device events only if necessary (with JS logic)
            Update_deviceEvents();
            Update_windowEvents();
            Update_elementsEvents();
        };

    // screen window events
    var Update_windowEvents = function() {

            $('#Update').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });

        };

    // device events
    var Update_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var Update_elementsExtraJS = function() {
            // screen (Update) extra code

        };

    // screen elements handler
    var Update_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#Update_UpdateHeader [name="UpdatePanelSwitchButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="Update_UpdatePanelMenu"]').panel("open");

                    }
                },
            }, '#Update_UpdateHeader [name="UpdatePanelSwitchButton"]');

            $(document).off("click", '#Update_UpdateContainer [name="UpdateNowButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        try {
                            categoriesListUpdate.execute({})
                        } catch (ex) {
                            console.log(ex.name + '  ' + ex.message);
                            hideSpinner();
                        };
                        toggle('Update_MessageLabel', 'mob', 'true');

                    }
                },
            }, '#Update_UpdateContainer [name="UpdateNowButton"]');

            $(document).off("click", '[name="HomeButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Home', {
                            reverse: false
                        });

                    }
                },
            }, '[name="HomeButton"]');

            $(document).off("click", '[name="ContactUsButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('ContactUs', {
                            reverse: false
                        });

                    }
                },
            }, '[name="ContactUsButton"]');

        };

    $(document).off("pagebeforeshow", "#Update").on("pagebeforeshow", "#Update", function(event, ui) {
        Update_beforeshow();
    });

    if (runBeforeShow) {
        Update_beforeshow();
    } else {
        Update_onLoad();
    }
};

$(document).off("pagecreate", "#Update").on("pagecreate", "#Update", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    Update_js();
});

SearchResults_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'BackToHomeButton': 'SearchResults_BackToHomeButton',
        'SearchResultsPanelSwitchButton': 'SearchResults_SearchResultsPanelSwitchButton',
        'ResultsList': 'SearchResults_ResultsList',
        'ResultsListitem': 'SearchResults_ResultsListitem',
        'mobilelistitembutton_6': 'SearchResults_mobilelistitembutton_6',
        'ResultsGrid': 'SearchResults_ResultsGrid',
        'TitleGridCell': 'SearchResults_TitleGridCell',
        'TitleLabel': 'SearchResults_TitleLabel',
        'NameGridCell': 'SearchResults_NameGridCell',
        'NameLabel': 'SearchResults_NameLabel',
        'IDGridCell': 'SearchResults_IDGridCell',
        'IDLabel': 'SearchResults_IDLabel',
        'HomeButton': 'SearchResults_HomeButton',
        'spacer_9': 'SearchResults_spacer_9',
        'ContactUsButton': 'SearchResults_ContactUsButton',
        'spacer_10': 'SearchResults_spacer_10',
        'UpdateButton': 'SearchResults_UpdateButton'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'SearchResults';

    /*
     * Nonvisual components
     */
    var datasources = [];

    getDoctorsLocal = new Apperyio.DataSource(getDoctors, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("SearchResults");
        },
        'onSuccess': function(data) {},
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': 'ResultsListitem',
            'SET': [{
                'PATH': ['doctorTitle'],
                'ID': 'TitleLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorName'],
                'ID': 'NameLabel',
                'ATTR': '@'
            }, {
                'PATH': ['doctorID'],
                'ID': 'IDLabel',
                'ATTR': '@'
            }]
        }],
        'requestMapping': [{
            'PATH': ['ar'],
            'TYPE': 'STRING',
            'ID': '___local_storage___',
            'ATTR': 'area'
        }, {
            'PATH': ['ca'],
            'TYPE': 'STRING',
            'ID': '___local_storage___',
            'ATTR': 'category'
        }, {
            'PATH': ['sp'],
            'TYPE': 'STRING',
            'ID': '___local_storage___',
            'ATTR': 'specialty'
        }]
    });

    datasources.push(getDoctorsLocal);

    /*
     * Events and handlers
     */

    // Before Show
    var SearchResults_beforeshow = function() {
            Apperyio.CurrentScreen = "SearchResults";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var SearchResults_onLoad = function() {
            SearchResults_elementsExtraJS();

            try {
                getDoctorsLocal.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };

            // TODO fire device events only if necessary (with JS logic)
            SearchResults_deviceEvents();
            SearchResults_windowEvents();
            SearchResults_elementsEvents();
        };

    // screen window events
    var SearchResults_windowEvents = function() {

            $('#SearchResults').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });
            $('#SearchResults').on({
                pageshow: function() {
                    try {
                        getDoctorsLocal.execute({})
                    } catch (ex) {
                        console.log(ex.name + '  ' + ex.message);
                        hideSpinner();
                    };
                },
            });

        };

    // device events
    var SearchResults_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var SearchResults_elementsExtraJS = function() {
            // screen (SearchResults) extra code

            /* ResultsList */

            listView = $("#SearchResults_ResultsList");
            theme = listView.attr("data-theme");
            if (typeof theme !== 'undefined') {
                var themeClass = "ui-btn-up-" + theme;
                listItem = $("#SearchResults_ResultsList .ui-li-static");
                $.each(listItem, function(index, value) {
                    $(this).addClass(themeClass);
                });
            }

            /* ResultsListitem */

        };

    // screen elements handler
    var SearchResults_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#SearchResults_SearchResultsHeader [name="BackToHomeButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Home', {
                            reverse: false
                        });

                    }
                },
            }, '#SearchResults_SearchResultsHeader [name="BackToHomeButton"]');
            $(document).off("click", '#SearchResults_SearchResultsHeader [name="SearchResultsPanelSwitchButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="SearchResults_SearchResultsPanelMenu"]').panel("open");

                    }
                },
            }, '#SearchResults_SearchResultsHeader [name="SearchResultsPanelSwitchButton"]');

            $(document).off("click", '#SearchResults_SearchResultsContainer [name="ResultsListitem"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        setVar_('doctor', 'SearchResults_IDLabel', 'text', '', this);
                        Apperyio.navigateTo('DoctorDetails', {
                            reverse: false
                        });

                    }
                },
            }, '#SearchResults_SearchResultsContainer [name="ResultsListitem"]');

            $(document).off("click", '[name="HomeButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Home', {
                            reverse: false
                        });

                    }
                },
            }, '[name="HomeButton"]');

            $(document).off("click", '[name="ContactUsButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('ContactUs', {
                            reverse: false
                        });

                    }
                },
            }, '[name="ContactUsButton"]');

            $(document).off("click", '[name="UpdateButton"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Update', {
                            reverse: false
                        });

                    }
                },
            }, '[name="UpdateButton"]');

        };

    $(document).off("pagebeforeshow", "#SearchResults").on("pagebeforeshow", "#SearchResults", function(event, ui) {
        SearchResults_beforeshow();
    });

    if (runBeforeShow) {
        SearchResults_beforeshow();
    } else {
        SearchResults_onLoad();
    }
};

$(document).off("pagecreate", "#SearchResults").on("pagecreate", "#SearchResults", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    SearchResults_js();
});